## docker.io 17.03.2

=== Makefile ===
.PHONY: all binary build cross deb help init-go-pkg-cache install manpages rpm run shell test test-docker-py test-integration-cli test-unit tgz validate win

# set the graph driver as the current graphdriver if not set
DOCKER_GRAPHDRIVER := $(if $(DOCKER_GRAPHDRIVER),$(DOCKER_GRAPHDRIVER),$(shell docker info 2>&1 | grep "Storage Driver" | sed 's/.*: //'))

# get OS/Arch of docker engine
DOCKER_OSARCH := $(shell bash -c 'source hack/make/.detect-daemon-osarch && echo $${DOCKER_ENGINE_OSARCH:-$$DOCKER_CLIENT_OSARCH}')
DOCKERFILE := $(shell bash -c 'source hack/make/.detect-daemon-osarch && echo $${DOCKERFILE}')

# env vars passed through directly to Docker's build scripts
# to allow things like `make KEEPBUNDLE=1 binary` easily
# `project/PACKAGERS.md` have some limited documentation of some of these
DOCKER_ENVS := \
	-e BUILD_APT_MIRROR \
	-e BUILDFLAGS \
	-e KEEPBUNDLE \
	-e DOCKER_BUILD_ARGS \
	-e DOCKER_BUILD_GOGC \
	-e DOCKER_BUILD_PKGS \
	-e DOCKER_DEBUG \
	-e DOCKER_EXPERIMENTAL \
	-e DOCKER_GITCOMMIT \
	-e DOCKER_GRAPHDRIVER=$(DOCKER_GRAPHDRIVER) \
	-e DOCKER_INCREMENTAL_BINARY \
	-e DOCKER_PORT \
	-e DOCKER_REMAP_ROOT \
	-e DOCKER_STORAGE_OPTS \
	-e DOCKER_USERLANDPROXY \
	-e TESTDIRS \
	-e TESTFLAGS \
	-e TIMEOUT \
	-e HTTP_PROXY \
	-e HTTPS_PROXY \
	-e NO_PROXY \
	-e http_proxy \
	-e https_proxy \
	-e no_proxy
# note: we _cannot_ add "-e DOCKER_BUILDTAGS" here because even if it's unset in the shell, that would shadow the "ENV DOCKER_BUILDTAGS" set in our Dockerfile, which is very important for our official builds

# to allow `make BIND_DIR=. shell` or `make BIND_DIR= test`
# (default to no bind mount if DOCKER_HOST is set)
# note: BINDDIR is supported for backwards-compatibility here
BIND_DIR := $(if $(BINDDIR),$(BINDDIR),$(if $(DOCKER_HOST),,bundles))
DOCKER_MOUNT := $(if $(BIND_DIR),-v "$(CURDIR)/$(BIND_DIR):/go/src/github.com/docker/docker/$(BIND_DIR)")

# This allows the test suite to be able to run without worrying about the underlying fs used by the container running the daemon (e.g. aufs-on-aufs), so long as the host running the container is running a supported fs.
# The volume will be cleaned up when the container is removed due to `--rm`.
# Note that `BIND_DIR` will already be set to `bundles` if `DOCKER_HOST` is not set (see above BIND_DIR line), in such case this will do nothing since `DOCKER_MOUNT` will already be set.
DOCKER_MOUNT := $(if $(DOCKER_MOUNT),$(DOCKER_MOUNT),-v /go/src/github.com/docker/docker/bundles)

# enable .go-pkg-cache if DOCKER_INCREMENTAL_BINARY and DOCKER_MOUNT (i.e.DOCKER_HOST) are set
PKGCACHE_DIR := $(if $(PKGCACHE_DIR),$(PKGCACHE_DIR),.go-pkg-cache)
PKGCACHE_MAP := gopath:/go/pkg goroot-linux_amd64_netgo:/usr/local/go/pkg/linux_amd64_netgo
DOCKER_MOUNT := $(if $(DOCKER_INCREMENTAL_BINARY),$(DOCKER_MOUNT) $(shell echo $(PKGCACHE_MAP) | sed -E 's@([^ ]*)@-v "$(CURDIR)/$(PKGCACHE_DIR)/\1"@g'),$(DOCKER_MOUNT))

GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
GIT_BRANCH_CLEAN := $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
DOCKER_IMAGE := docker-dev$(if $(GIT_BRANCH_CLEAN),:$(GIT_BRANCH_CLEAN))
DOCKER_PORT_FORWARD := $(if $(DOCKER_PORT),-p "$(DOCKER_PORT)",)

DOCKER_FLAGS := docker run --rm -i --privileged $(DOCKER_ENVS) $(DOCKER_MOUNT) $(DOCKER_PORT_FORWARD)
BUILD_APT_MIRROR := $(if $(DOCKER_BUILD_APT_MIRROR),--build-arg APT_MIRROR=$(DOCKER_BUILD_APT_MIRROR))
export BUILD_APT_MIRROR

# if this session isn't interactive, then we don't want to allocate a
# TTY, which would fail, but if it is interactive, we do want to attach
# so that the user can send e.g. ^C through.
INTERACTIVE := $(shell [ -t 0 ] && echo 1 || echo 0)
ifeq ($(INTERACTIVE), 1)
	DOCKER_FLAGS += -t
endif

DOCKER_RUN_DOCKER := $(DOCKER_FLAGS) "$(DOCKER_IMAGE)"

default: binary

all: build ## validate all checks, build linux binaries, run all tests\ncross build non-linux binaries and generate archives
	$(DOCKER_RUN_DOCKER) bash -c 'hack/validate/default && hack/make.sh'

binary: build ## build the linux binaries
	$(DOCKER_RUN_DOCKER) hack/make.sh binary

build: bundles init-go-pkg-cache
	docker build ${BUILD_APT_MIRROR} ${DOCKER_BUILD_ARGS} -t "$(DOCKER_IMAGE)" -f "$(DOCKERFILE)" .

bundles:
	mkdir bundles

cross: build ## cross build the binaries for darwin, freebsd and\nwindows
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary binary cross

deb: build  ## build the deb packages
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary build-deb


help: ## this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z_-]+:.*?## / {sub("\\\\n",sprintf("\n%22c"," "), $$2);printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)

init-go-pkg-cache:
	mkdir -p $(shell echo $(PKGCACHE_MAP) | sed -E 's@([^: ]*):[^ ]*@$(PKGCACHE_DIR)/\1@g')

install: ## install the linux binaries
	KEEPBUNDLE=1 hack/make.sh install-binary

manpages: ## Generate man pages from go source and markdown
	docker build -t docker-manpage-dev -f "man/$(DOCKERFILE)" ./man
	docker run --rm \
		-v $(PWD):/go/src/github.com/docker/docker/ \
		docker-manpage-dev

rpm: build ## build the rpm packages
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary build-rpm

run: build ## run the docker daemon in a container
	$(DOCKER_RUN_DOCKER) sh -c "KEEPBUNDLE=1 hack/make.sh install-binary run"

shell: build ## start a shell inside the build env
	$(DOCKER_RUN_DOCKER) bash

yaml-docs-gen: build ## generate documentation YAML files consumed by docs repo
	$(DOCKER_RUN_DOCKER) sh -c 'hack/make.sh yaml-docs-generator && ( root=$$(pwd); cd bundles/latest/yaml-docs-generator; mkdir docs; ./yaml-docs-generator --root $${root} --target $$(pwd)/docs )'

test: build ## run the unit, integration and docker-py tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary cross test-unit test-integration-cli test-docker-py

test-docker-py: build ## run the docker-py tests
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary test-docker-py

test-integration-cli: build ## run the integration tests
	$(DOCKER_RUN_DOCKER) hack/make.sh build-integration-test-binary dynbinary test-integration-cli

test-unit: build ## run the unit tests
	$(DOCKER_RUN_DOCKER) hack/make.sh test-unit

tgz: build ## build the archives (.zip on windows and .tgz\notherwise) containing the binaries
	$(DOCKER_RUN_DOCKER) hack/make.sh dynbinary binary cross tgz

validate: build ## validate DCO, Seccomp profile generation, gofmt,\n./pkg/ isolation, golint, tests, tomls, go vet and vendor
	$(DOCKER_RUN_DOCKER) hack/validate/all

win: build ## cross build the binary for windows
	$(DOCKER_RUN_DOCKER) hack/make.sh win

.PHONY: swagger-gen
swagger-gen:
	docker run --rm -v $(PWD):/go/src/github.com/docker/docker \
		-w /go/src/github.com/docker/docker \
		--entrypoint hack/generate-swagger-api.sh \
		-e GOPATH=/go \
		quay.io/goswagger/swagger:0.7.4

=== debian/changelog ===
docker.io (17.03.2-0ubuntu1~17.10.1) artful; urgency=medium

  * Backport to Artful (LP: #1732368)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 17 Nov 2017 13:38:42 +1300

docker.io (17.03.2-0ubuntu1) bionic; urgency=medium

  * Update to 17.03.2 upstream release

 -- Tianon Gravi <tianon@debian.org>  Wed, 01 Nov 2017 12:30:17 -0700

docker.io (1.13.1-0ubuntu6) artful; urgency=medium

  * Add missing "runc" patches for LXD-enablement

 -- Tianon Gravi <tianon@debian.org>  Wed, 11 Oct 2017 19:38:03 -0700

docker.io (1.13.1-0ubuntu5) artful; urgency=medium

  * Replace "runc" dependency with a multiorig copy of Docker's exact supported
    commit contents (installed as "/usr/bin/docker-runc" mirroring upstream's
    package)
  * Replace "containerd" in the same way (with the exact upstream-supported
    commit, binaries installed as "/usr/bin/docker-containerd*")

 -- Tianon Gravi <tianon@debian.org>  Fri, 29 Sep 2017 13:22:39 -0700

docker.io (1.13.1-0ubuntu4) artful; urgency=medium

  * d/tests/docker-in-lxd: Better handle DNS with systemd-resolved.

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 21 Sep 2017 01:12:33 -0400

docker.io (1.13.1-0ubuntu3) artful; urgency=medium

  * d/tests/docker-in-lxd: check for network-up has a race condition when
    systemd-resolved is used.  Add an additional check for a real DNS server
    in systemd-resolve --status.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Sep 2017 23:32:16 -0700

docker.io (1.13.1-0ubuntu2) artful; urgency=medium

  * d/tests/docker-in-lxd: copy more apt config into container
  * d/golang-github-docker-docker-dev.install: install missing packages.
    (LP: #1714564)
  * d/control: Add Build-Depend on tzdata.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 04 Sep 2017 13:31:34 +1200

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders: Docker Packaging Team <docker-maint@lists.alioth.debian.org>,
           Tianon Gravi <tianon@debian.org>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: bash-completion,
               btrfs-tools,
               ca-certificates,
               cmake,
               debhelper (>= 9),
               dh-exec,
               dh-systemd,
               git,
               go-md2man (>= 1.0.3~),
               golang-any (>= 2:1.7~) | golang-1.7-go,
               libapparmor-dev,
               libdevmapper-dev (>= 2:1.02.68~),
               libseccomp-dev,
               pkg-config,
               procps,
               tzdata
Standards-Version: 3.9.8
Homepage: https://dockerproject.org
Vcs-Git: https://anonscm.debian.org/git/docker/docker.io.git
Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker.io.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: adduser, iptables, ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates,
            cgroupfs-mount | cgroup-lite,
            git,
            ubuntu-fan,
            xz-utils,
            ${apparmor:Recommends}
Provides: docker-containerd, docker-runc
Conflicts: docker-containerd, docker-runc
Replaces: docker (<< 1.5~), docker-containerd, docker-runc
Breaks: docker (<< 1.5~)
Suggests: aufs-tools,
          btrfs-tools,
          debootstrap,
          docker-doc,
          rinse,
          zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: ${misc:Depends}
Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
Provides: golang-docker-dev
Description: Externally reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: golang-docker-dev
Section: oldlibs
Priority: extra
Architecture: all
Depends: golang-github-docker-docker-dev, ${misc:Depends}
Description: Transitional package for golang-github-docker-docker-dev
 This is a transitional package to ease upgrades to the
 golang-github-docker-docker-dev package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_GOPKG := github.com/docker/docker

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)

# helpful variables for deduplication
export DOCKER_VERSION := $(shell cat VERSION)

export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(DOCKER_VERSION))
export BUILDTIME := $(shell dpkg-parsechangelog -SDate)

# have "make.sh" keep "bundle/$(DOCKER_VERSION)" around between runs (we clean it up appropriately ourselves)
export KEEPBUNDLE := 1

# AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
# same story with SELinux
export DOCKER_BUILDTAGS := apparmor seccomp selinux

# since "gccgo" doesn't ship the "dist" go tool (and isn't likely to start), let's use that for now to detect gc vs gccgo
export DOCKER_BUILD_TARGET := $(shell go tool dist env > /dev/null 2>&1 && echo dynbinary || echo dyngccgo)

# prefer Go 1.7 explicitly if it's available (golang-1.7-go)
export PATH := /usr/lib/go-1.7/bin:$(PATH)


APPARMOR_RECOMMENDS := $(shell dpkg-vendor --is Ubuntu && echo apparmor)
BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

override_dh_gencontrol:
	echo 'apparmor:Recommends=$(APPARMOR_RECOMMENDS)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	dh_gencontrol


override_dh_auto_configure:
	# set up GOPATH symlink farm
	# runc
	mkdir -p '$(OUR_GOPATH)/src/github.com/opencontainers'
	ln -sfT '$(CURDIR)/runc' '$(OUR_GOPATH)/src/github.com/opencontainers/runc'
	# containerd
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/containerd' '$(OUR_GOPATH)/src/github.com/docker/containerd'
	# libnetwork
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/libnetwork' '$(OUR_GOPATH)/src/github.com/docker/libnetwork'
	# docker
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)' '$(OUR_GOPATH)/src/github.com/docker/docker'

override_dh_auto_build-indep:
	# noop

override_dh_auto_build-arch:
	@bash -c '{ [ "$$DOCKER_GITCOMMIT" ]; } || { echo; echo "error: missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits"; echo; exit 2; } >&2'
	
	# compile runc
	cd '$(OUR_GOPATH)/src/github.com/opencontainers/runc' \
		&& make \
			BUILDTAGS='seccomp apparmor selinux' \
			COMMIT='$(shell . hack/dockerfile/binaries-commits && echo "$$RUNC_COMMIT")'
	# (we use the exact commit Docker does, so we pass that value to "runc" when we build it)
	
	# compile containerd
	LDFLAGS='' make -C containerd \
		GIT_COMMIT='$(shell . hack/dockerfile/binaries-commits && echo "$$CONTAINERD_COMMIT")'
	# (we use the exact commit Docker does, so we pass that value to "containerd" when we build it)
	
	# compile docker ("cd" first to ensure we build from within GOPATH)
	cd '$(OUR_GOPATH)/src/$(DH_GOPKG)' \
		&& '$(CURDIR)/hack/make.sh' $(DOCKER_BUILD_TARGET)
	
	# compile man pages
	./man/md2man-all.sh -q
	
	# compile docker-proxy (from libnetwork)
	go build -o libnetwork/docker-proxy github.com/docker/libnetwork/cmd/proxy
	
	# compile docker-init (tini)
	cd tini \
		&& cmake . \
		&& make tini-static


override_dh_install:
	## Do not install extra license files:
	dh_install -XLICENSE


override_dh_auto_install:
	# we use dh_install / dh-exec for installing files where they need to be


override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# run unit tests
	cd '$(OUR_GOPATH)/src/$(DH_GOPKG)' \
		&& export TESTFLAGS='-test.short' \
		&& '$(CURDIR)/hack/make.sh' test-unit
endif


override_dh_installinit:
	dh_installinit --name=docker --no-restart-on-upgrade


override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev --priority=z80


override_dh_auto_clean:
	dh_auto_clean
	
	# OUR_GOPATH is created by us
	rm -rf '$(OUR_GOPATH)'


%:
	dh $@ --with=systemd,bash-completion
